#include <algorithm>
#include <iostream>

#include "Interfaces.h"
#include "ParaWeatherData.h"
#include "CurrentConditionBoard.h"
#include "StatisticBoard.h"

int main(int argc, char *argv[])
{

    ParaWeatherData * wdata = new ParaWeatherData;
    CurrentConditionBoard* currentB = new CurrentConditionBoard(*wdata);
    StatisticBoard* statisticB = new StatisticBoard(*wdata);

    wdata->SensorDataChange(10.2, 28.2, 1001);
    wdata->SensorDataChange(12, 30.12, 1003);
    wdata->SensorDataChange(10.2, 26, 806);
    wdata->SensorDataChange(10.3, 35.9, 900);

    wdata->removeOb(currentB);

    wdata->SensorDataChange(100, 40, 1900);  

    delete statisticB;
    delete currentB;
    delete wdata;

    return 0;
}

/*Output
_____CurrentConditionBoard_____
humidity: 10.2
temperature: 28.2
pressure: 1001
_______________________________
________StatisticBoard_________
lowest  temperature: 28.2
highest temperature: 28.2
average temperature: 28.2
_______________________________
_____CurrentConditionBoard_____
humidity: 12
temperature: 30.12
pressure: 1003
_______________________________
________StatisticBoard_________
lowest  temperature: 28.2
highest temperature: 30.12
average temperature: 29.16
_______________________________
_____CurrentConditionBoard_____
humidity: 10.2
temperature: 26
pressure: 806
_______________________________
________StatisticBoard_________
lowest  temperature: 26
highest temperature: 30.12
average temperature: 28.1067
_______________________________
_____CurrentConditionBoard_____
humidity: 10.3
temperature: 35.9
pressure: 900
_______________________________
________StatisticBoard_________
lowest  temperature: 26
highest temperature: 35.9
average temperature: 30.055
_______________________________
________StatisticBoard_________
lowest  temperature: 26
highest temperature: 40
average temperature: 32.044
_______________________________
*/